/* Swiat.c */
#include "swiat.h"

/* wiat budzi si do (rz)ycia... */
void init_swiata()
{
    int i;
    struct _czas tmp;
    tmp.rok = 1;
    tmp.dzien_miesiaca = 1;
    tmp.miesiac = 1;
    tmp.dzien_miesiaca = 1;
    tmp.tura = 43200;
    tura = 1;
    ustaw_plik(&Plik, "SWIA00");
    wczytaj_swiat(&Plik, &swiat);
    swiat.x = 0;
    swiat.y = 0;
    swiat.z = 10;
/* Czyszczenie tablicy zdarze */
    for (i = 0; i < MAXZD; i++) {
	zdarzenie[i].aktualne = 0;
    }
    ustaw_plik(&Plik, "ZDAR08");
    wczytaj_zdarzenia(&Plik);
    return;
}

void wczytaj_swiat(struct _plik *plik, struct _swiat *Swiat)
{
    sread(plik, Swiat, sizeof(struct _swiat));
}

void wczytaj_zdarzenia(struct _plik *in)
{
    int j;
    sread(in, &ile_zdarzen, sizeof(ile_zdarzen));
    j = 0;
    while (j < ile_zdarzen) {
	sread(in, &zdarzenie[j], sizeof(struct Zdarzenie));
	j++;
    }
}

void zapisz_zdarzenia(char *out, long int *ile)
{
    int j;
    *ile = 0;
    memcpy(&out[*ile], &ile_zdarzen, sizeof(ile_zdarzen));
    (*ile) += sizeof(ile_zdarzen);
    j = 0;
    while (j < ile_zdarzen) {
	memcpy(&out[*ile], &zdarzenie[j], sizeof(struct Zdarzenie));
	(*ile) += sizeof(struct Zdarzenie);
	j++;
    }
}

void obsluz_zdarzenia(int potw)
{
    int i;
    struct Zadanie zadanie;
    zadanie.typ = 0;
    zadanie.nr_potwora = -1;
    zadanie.wygasanie = 10000;
    for (i = 0; i < MAXZD; i++) {
	if (zdarzenie[i].aktualne == 1) {
	    if ((bylo(&zdarzenie[i].start) != -1
		 || !zdarzenie[i].start.rok)
		&& (bylo(&zdarzenie[i].stop) != 1
		    || !zdarzenie[i].stop.rok) && (zdarzenie[i].dawca == -1
						   || zdarzenie[i].dawca ==
						   potw)
		&& (zdarzenie[i].wykonane == -1
		    || zdarzenie[zdarzenie[i].wykonane].spelnione)) {
		switch (zdarzenie[i].typ) {
		case 0:
		    dodaj_napis(zdarzenie[i].komunikat);
		    if (zdarzenie[i].jednorazowe)
			zdarzenie[i].aktualne = 0;
		    break;
		case 1:
		    {
			int j;
			dodaj_napis(zdarzenie[i].komunikat);
			zadanie.nr_potwora = zdarzenie[i].nr_potwora;
			j = dodaj_zadanie(&zadanie,
					  Poziom.Istoty.poczatek->nast);
			if (zdarzenie[i].nr_zdarzenia != -1) {
			    zdarzenie[zdarzenie[i].nr_zdarzenia].
				nr_zadania = j;
/*			    zdarzenie[zdarzenie[i].nr_zdarzenia].
				wykonawca = Poziom.Istoty.poczatek->nast; */
			}
			if (zdarzenie[i].jednorazowe)
			    zdarzenie[i].aktualne = 0;
			break;
		    }
		case 2:
		    if (zdarzenie[i].nr_zadania == -1 ||
			/*zdarzenie[i].wykonawca */ Gracz->
			zadanie[zdarzenie[i].nr_zadania].spelnione) {
			/* if (zdarzenie[i].nr_zadania == -1) {
			   zdarzenie[i].wykonawca = Gracz;
			   } */
			dodaj_napis(zdarzenie[i].komunikat);
			dodaj_ladnie( /*zdarzenie[i].wykonawca */ Gracz->x,
				     /*zdarzenie[i].wykonawca */ Gracz->y,
				     1,
				     zdarzenie[i].nr_przedmiotu, -1, -1,
				     &Poziom.Przedmioty);
			if (zdarzenie[i].jednorazowe)
			    zdarzenie[i].aktualne = 0;
		    }
		    break;
		default:
		    {
			char kom[300];
			sprintf(kom,
				_
				("Zawiadom autorw i bd tak miy, eby powiedzie im, e wystpio zdarzenie o typie %d (a nie powinno byo). "),
				zdarzenie[i].typ);
			dodaj_napis(kom);
			break;
		    }
		}
		zdarzenie[i].spelnione = 1;
	    }

	}
    }

}
