/* convks.c (konwerter pliku z tekstami ksiek) */
#include <stdio.h>
#include "fake.h"
#include "ksiazki.h"

FILE *out;

int main()
{
    int i = 0;
    char buf[100000];
    if ((out = fopen("ksiazkib", "wb")) == NULL) {
	fprintf(stderr, _("Nie mog otworzy ksiazkib!\n"));
	exit(1);
    }
    if (!init_parser("ksiazki")) {
	fprintf(stderr, _("Nie mog otworzy ksiazki!\n"));
	exit(1);
    }
    while (!ustaw_kawalek("{", "}")) {
	strcpy(ksiazki.ks[i].tekst,
	       parser_string(buf, "Tekst:", 1, "Co si le sparsowao"));
	ksiazki.ks[i].flagi = parser_liczba("Fl:", 1, 0, SP_FL_KS);
	ksiazki.ks[i].efekty = parser_liczba("Ef:", 1, 0, SP_FL_KS);
	i++;
    }
    fwrite(&ksiazki, sizeof(struct _ksiazki), 1, out);
    end_parser();
    return 0;
}
