/* czas.c */
#include "czas.h"

void init_czasu()
{
    dzien = 1;
    czas.rok = 1;
    czas.miesiac = 1;
    czas.dzien_miesiaca = 1;
    czas.tura = 43200;		/* 12:00 */
}

int godzina()
{
    return czas.tura / 3600;
}

int minuta()
{
    return (czas.tura - godzina() * 3600) / 60;
}

int bylo(struct _czas *C)
{
    if (C->rok != -1) {
	if (C->rok < czas.rok)
	    return 1;
	if (C->rok > czas.rok)
	    return -1;
    }
    if (C->miesiac != -1) {
	if (C->miesiac < czas.miesiac)
	    return 1;
	if (C->miesiac > czas.miesiac)
	    return -1;
    }
    if (C->dzien_miesiaca != -1) {
	if (C->dzien_miesiaca < czas.dzien_miesiaca)
	    return 1;
	if (C->dzien_miesiaca > czas.dzien_miesiaca)
	    return -1;
    }
    if (C->tura < czas.tura)
	return 1;
    if (C->tura > czas.tura)
	return -1;
    return 0;
}

int sekunda()
{
    return (czas.tura - godzina() * 3600 - minuta() * 60);
}

void tick()
{
    czas.tura++;
    tick_na_poziomie();
    if (czas.tura == 21600) {	/* 6:00 */
	dodaj_napis(_("Wyszo soce. "));
	dzien = 1;
    }
    if (czas.tura == 79200) {	/* 22:00 */
	dodaj_napis(_("Nastaa noc. "));
	dzien = 0;
    }
    if (!(czas.tura % 86400)) {
	czas.tura = 0;
	czas.dzien_miesiaca++;
	if (czas.dzien_miesiaca > 30) {
	    czas.dzien_miesiaca = 1;
	    czas.miesiac++;
	    if (czas.miesiac > 12) {
		czas.miesiac = 1;
		czas.rok++;
	    }
	}
    }
}
