/* rozne.c */
#include "rozne.h"

/* Do losowych:
 *   im wicej, tym gorzej
 */

int losowa100()
{
    return 1 + (int) (100.0 * rand() / (RAND_MAX + 1.0));

}

int losowa10()
{
    return 1 + (int) (10.0 * rand() / (RAND_MAX + 1.0));

}

int losowa4()
{
    return 1 + (int) (4.0 * rand() / (RAND_MAX + 1.0));
}

int losowa(int max)
{
    return 1 + (int) (1.0 * max * rand() / (RAND_MAX + 1.0));
}

int losowaoddo(int min, int max)
{
    return min + (int) (1.0 * (max - min + 1) * rand() / (RAND_MAX + 1.0));
}

void init_locale()
{
#ifdef OPT
    setlocale(LC_ALL, "");
    old_loc = setlocale(LC_ALL, NULL);
    sav_loc = strdup(old_loc);
    if (getenv("LC_ALL"))
	strncpy(loc_env, getenv("LC_ALL"), 50);
    strncpy(_locale, sav_loc, 15);
    if (strcmp(_locale, "pl_PL") && (strcmp(_locale, "pl"))) {
#ifdef LINUX
	setenv("LC_ALL", "en", 1);
	strcpy(_locale, "en");
#endif
#if defined(CYGWIN) || defined(_DJGPP)
	setenv("LC_ALL", "pl", 1);
	strcpy(_locale, "pl");
#endif
	setlocale(LC_ALL, "");
    }
    bindtextdomain(PACKAGE, LOCALEDIR);
    textdomain(PACKAGE);
#endif
}

void end_locale()
{
#ifdef OPT
    setlocale(LC_ALL, sav_loc);
    my_free(sav_loc);
    setenv("LC_ALL", loc_env, 1);
#endif
}
