
#ifndef struct_przedmioty_ID_h
#define struct_przedmioty_ID_h

#include "config.h"

#include "przedmiotyconst.h"
#include "przedm.h"

long int Klasa[MAXKLAS + 1][MAXPOZ + 1];	/* Tablica sum "punktw prawdopodobiestwa" poszczeglnych klas */

long int suma_pr_prz[MAXPOZ + 1];	/* Tablica sum w ogle */

/* Rekord tablicy waciwoci przedmiotw */
struct przedmiotID {
    char typ;
    long int klasa_przedmiotu;	/* Albo te klasy (np. KL_ZLOTO+KL_TARCZE - zota tarcza) */
    int podklasa_przedmiotu;
    char nazwa[MAXPRZYP][50];
    char mnoga[50];
    char d_mnoga[50];
    int czest;			/* Jak czsto si losuje */
    int waga;
    int wrecz[3][2];		/* Min i max wspczynnikw zadawanych obrae */
    int mod_traf[2];		/* Modyfikator celnoci (min i max) */
    int material[MAXMATERIALOW][3];	/* Tablica czstoci wystpowania materiaw (odpowiednio: czsto, od ktrego poziomu, o ile potem ronie) */
    int mat_sum;		/* Suma czstoci (dla aktualnego poziomu) */
    int ile_min, ile_max;
    int flagi;
    int pozywnosc;
    int cena;
    int pancerz;		/* czyli ile punktw pancerza przybywa wraz z zaoeniem przedmiotu */
    int poziom;
    int rodzaj;			/* gramatyczny */
    int wielkosc;		/* "wielko" przedmiotu */
    int kolor;
};

/* Tablica waciwoci przedmiotw */
struct PrzedmiotyID {
    struct przedmiotID ID[MAXPRZEDM];
    int ile;
} przedmiotyID;

/* Modyfikatory s _procentowe_ */
struct _material {
    int pancerz[2];		/* czyli bonus do punktw pancerza (min i max) */
    int wrecz[3][2];		/* Min i max wspczynnikw zadawanych obrae */
    int mod_traf[2];		/* Modyfikator celnoci (min i max) */
    int mod_ceny[2];		/* Modyfikator ceny (min i max) */
    int kolor;
} material[MAXMATERIALOW];

struct przedmiot_zn {
    int znany;
    char nazwa[MAXPRZYP][50];
    char mnoga[50];
    char d_mnoga[50];
} preID[MAXPRZEDM];

struct napoje_preID_ {
    char nazwa[MAXPRZYP][50][MAXNAPOJ];
    char mnoga[50][MAXNAPOJ];
    char d_mnoga[50][MAXNAPOJ];
    int kolor[MAXNAPOJ];
    short int wykorzystany[MAXNAPOJ];
    int ile;
} napoje_preID;

struct zwoje_preID_ {
    char nazwa[MAXPRZYP][50][MAXZWOJ];
    char mnoga[50][MAXZWOJ];
    char d_mnoga[50][MAXZWOJ];
    short int wykorzystany[MAXZWOJ];
    int ile;
} zwoje_preID;
#endif
