/* umiejetnosci.h */
#ifndef umiejetnosci_h
#define umiejetnosci_h

#include <assert.h>

#include "config.h"

#include "wspolczynniki.h"
#include "umiejetnosciconst.h"
#include "postac.h"
#include "poziom.h"
#include "ekran.h"
#include "rozne.h"

typedef struct umiejetnosc *wsk_um;

/* Brakuje jeszcze systemu wiedzy teoretycznej/praktycznej ... */
struct umiejetnosc {
    int ile_podum;		/* Ile podumiejtnoci */
    wsk_um podum[MAXPODUM];	/* Podumiejtnoci */
    wsk_um nadum;		/* Nadumiejtno */
    int nr;			/* indeks w tab_um */
    int cecha;			/* wspczynnik, od ktrego zaley rozwj cechy */
    int dozwolona;		/* Czy mona jej si uczy od razu */
};

wsk_um tab_um[ILOSC_UMIEJETNOSCI];

void init_umiejetnosci();

void dodaj_umiejetnosc(int nr, int nr_rodzica, int cecha, int dozw);

void cwicz_umiejetnosc(struct istota *Postac, wsk_um umiejetnosc,
		       wsk_um poza_ktora, int o_ile, int praktycznie);

int uzyj_umiejetnosci(struct istota *Postac, int umiejetnosc);

void wyswietl_umiejetnosci(struct istota *Postac);

#endif
